<?php

namespace app\admin\logic;

use app\model\ActionModel;
use app\model\CommonModel;
use think\exception\ValidateException;
use think\facade\Db;
use think\response\Json;

class ActionLogic extends BaseLogic
{
    //获取权限列表
    public static function List(int $menuid = 0): Json
    {
        $data = ActionModel::alias('a')
            ->field('a.*,action_name')
            ->leftJoin('action_list l', 'a.action_code=l.action_code')
            ->where(['menuid' => $menuid])
            ->select()
            ->toArray();
        return json_show(CommonModel::$success, '获取成功', $data);
    }

    //添加权限
    public static function Add(array $data = []): Json
    {
        $rs = ActionModel::field('id')
            ->where(['menuid' => $data['menuid'], 'action_code' => $data['action_code']])
            ->findOrEmpty()
            ->isEmpty();
        if (!$rs) throw new ValidateException('此功能已存在');

        $data = array_merge($data, [
            'addtime' => date('Y-m-d H:i:s'),
            'updatetime' => date('Y-m-d H:i:s'),
        ]);

        return ActionModel::create($data)->save() ? json_show(CommonModel::$success, '添加成功') : json_show(CommonModel::$error_default, '添加失败');
    }

    //获取权限详情
    public static function Read(int $id = 0): Json
    {
        $menu = ActionModel::alias('a')
            ->field('a.*,action_name')
            ->leftJoin('action_list l', 'a.action_code=l.action_code')
            ->where('a.id', $id)
            ->findOrEmpty()
            ->toArray();

        return empty($menu) ? json_show(CommonModel::$error_param, '未找到对应的数据') : json_show(CommonModel::$success, '获取成功！', $menu);

    }

    //编辑权限
    public static function Edit(array $data = []): Json
    {
    }

    //删除权限
    public static function Delete(array $data = []): Json
    {
    }

    //启禁用权限
    public static function Status(array $data = []): Json
    {
        $rs = ActionModel::where(['id' => $data['id']])
            ->where('status', '<>', $data['status'])
            ->save(['status' => $data['status'], 'updatetime' => date('Y-m-d H:i:s')]);
        return $rs ? json_show(CommonModel::$success, '操作成功') : json_show(CommonModel::$error_default, '操作失败');
    }

}